'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var prosemirrorState = require('prosemirror-state');

function imageDropHandler(schema, url) {
  var plugin = new prosemirrorState.Plugin({
    props: {
      handleDOMEvents: {
        drop: function (view, event) {
          var files = event.dataTransfer.files;
          var sel = view.state.tr.curSelection;
          console.log(sel.ranges, JSON.stringify(sel));

          if (files.length == 0) {
            return
          }
          
          if (event.preventDefault != undefined) {
            event.preventDefault();
          } else {
            window.event.returnValue=false;
          }

          ([].concat( files[0] )).forEach( function (file, i, filelist) {
            console.log('drop', file);
            if (
              file.type != 'image/svg+xml' &&
              file.type != 'image/png' &&
              file.type != 'image/jpeg' &&
              file.type != 'image/gif'
            ) {
              console.log('not image', file.type);
              return
            }
            var formData = new FormData();
            formData.append('file', file);
            var x = new XMLHttpRequest();
            x.open('POST', url);
            x.onload = function(ret) {
              if (x.readyState == 4 && x.status == 200) {
                var pos = view.posAtCoords({left: event.clientX, top: event.clientY});
                view.dispatch(
                  view.state.tr.replaceWith(pos.pos, pos.pos,
                    schema.nodes.image.create({
                      src: x.responseText
                    }
                  )
                ).scrollIntoView());
              }
            };
            x.send(formData);
          });
        }
      }
    }
  });
  return plugin
}

exports.imageDropHandler = imageDropHandler;
//# sourceMappingURL=index.js.map
